
-- trailingTruck
--@author Outlaw
--@date 10/10/08

trailingTruck = {};
function trailingTruck.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function trailingTruck:load(xmlFile)

function trailingTruck:new(configFile, positionX, offsetY, positionZ, rotationY, customMt)

    if trailingTruck_mt == nil then
        trailingTruck_mt = Class(trailingTruck, Trailer);
    end;

    local mt = customMt;
    if mt == nil then
        mt = trailingTruck_mt;
    end;
    local instance = Trailer:new(configFile, positionX, offsetY, positionZ, rotationY, mt);
    local xmlFile = loadXMLFile("TempConfig", configFile);
	
	instance.wheel_1 = getXMLFloat(xmlFile, "vehicle.trailingTruck#wheel_1");
	instance.wheel_2 = getXMLFloat(xmlFile, "vehicle.trailingTruck#wheel_2");
	instance.wheel_3 = getXMLFloat(xmlFile, "vehicle.trailingTruck#wheel_3");
	instance.wheel_4 = getXMLFloat(xmlFile, "vehicle.trailingTruck#wheel_4");
	instance.wheel_5 = getXMLFloat(xmlFile, "vehicle.trailingTruck#wheel_5");
	instance.wheel_6 = getXMLFloat(xmlFile, "vehicle.trailingTruck#wheel_6");
	instance.wheel_7 = getXMLFloat(xmlFile, "vehicle.trailingTruck#wheel_7");
	instance.wheel_8 = getXMLFloat(xmlFile, "vehicle.trailingTruck#wheel_8");
	instance.lenkachsekey = getXMLString(xmlFile, "vehicle.trailingTruck#key");
	instance.trailingTruckBackAngle = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailingTruck#backAngle"), 25);
	instance.trailingTruckFrontAngle = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailingTruck#frontAngle"), 12);
	instance.trailingTruckBackAngle2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailingTruck#backAngle2"), 25);
	instance.trailingTruckFrontAngle2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailingTruck#frontAngle2"), 12);
	instance.trailingTruckActive = true;
	


    delete(xmlFile);
    return instance;
end;

function trailingTruck:delete()
    Trailer.delete(self);
end;


function trailingTruck:mouseEvent(posX, posY, isDown, isUp, button)
    Trailer.mouseEvent(self, posX, posY, isDown, isUp, button);
end;



function trailingTruck:keyEvent(unicode, sym, modifier, isDown)
    Trailer.keyEvent(self, unicode, sym, modifier, isDown);
	  if isDown and sym == Input[self.lenkachsekey] then
		self.trailingTruckActive = not self.trailingTruckActive;
	end;
end;


function trailingTruck:update(dt)
	Trailer.update(self, dt);
	if g_currentMission.currentVehicle ~= nil then
		if g_currentMission.currentVehicle.attachedTrailer == self then

		
			

			if self.trailingTruckActive then
				local angle = 0;
				local frontAngle = 0;
				local backAngle = 0;	
				local frontAngle2 = 0;
				local backAngle2 = 0;
				local x1,y1,z1 = localDirectionToWorld(self.attacherVehicle.rootNode, 0, 0, 1)
				local x2,y2,z2 = localDirectionToWorld(self.rootNode, 0, 0, 1)
				local dot = x1*x2 + z1*z2;
				dot = dot / (Utils.vector2Length(x1,z1) * Utils.vector2Length(x2,z2))
				angle = math.acos(dot);
	            local cy = z1 * x2 - x1 * z2;
	            if cy < 0 then
	                angle = -angle;
	            end;
				
				frontAngle = (self.trailingTruckFrontAngle * (angle / 50)) * -1;
				backAngle  = self.trailingTruckBackAngle * (angle / 50);	
				frontAngle2 = (self.trailingTruckFrontAngle2 * (angle / 50)) * -1;
				backAngle2  = self.trailingTruckBackAngle2 * (angle / 50);				
								
			
				for i=1, table.getn(self.wheels) do
					local x,y,z = getRotation(self.wheels[i].repr);			
					local newX, newY, newZ = getWheelShapePosition(self.wheels[i].node, self.wheels[i].wheelShape);
					setTranslation(self.wheels[i].repr, newX, newY, newZ);
					local axleSpeed = getWheelShapeAxleSpeed(self.wheels[i].node, self.wheels[i].wheelShape)*3.14159/180;
					x = x+axleSpeed*dt/1000.0;
					
					if self.wheel_1 ~= nil and self.wheel_2 ~= nil then
						if i == self.wheel_1 or i == self.wheel_2 then
							setWheelShapeProps(self.wheels[i].node, self.wheels[i].wheelShape, 0, 0, backAngle);
							setRotation(self.wheels[i].repr, x, backAngle, z);
						end;
					end;
					if self.wheel_3 ~= nil and self.wheel_4 ~= nil then
						if i == self.wheel_3 or i == self.wheel_4 then
							setWheelShapeProps(self.wheels[i].node, self.wheels[i].wheelShape, 0, 0, frontAngle);
							setRotation(self.wheels[i].repr, x, frontAngle, z);
						end;
					end;
						if self.wheel_5 ~= nil and self.wheel_6 ~= nil then
						if i == self.wheel_5 or i == self.wheel_6 then
							setWheelShapeProps(self.wheels[i].node, self.wheels[i].wheelShape, 0, 0, backAngle2);
							setRotation(self.wheels[i].repr, x, backAngle2, z);
						end;
					end;
					if self.wheel_7 ~= nil and self.wheel_8 ~= nil then
						if i == self.wheel_7 or i == self.wheel_8 then
							setWheelShapeProps(self.wheels[i].node, self.wheels[i].wheelShape, 0, 0, frontAngle2);					
							setRotation(self.wheels[i].repr, x, frontAngle2, z);
						end;
					end;
				end;
			end;
			
			
			
			
		end;
	end;
end;


function trailingTruck:draw()
	if self.trailingTruckActive then	
		g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(Input[self.lenkachsekey]))..": Lenkachse ausschalten");
	else
		g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(Input[self.lenkachsekey]))..": Lenkachse einschalten");
	end;
    Trailer.draw(self);
end;


function trailingTruck:onDetach()
    Trailer.onDetach(self);
end;

